{{- if .Values.autoscaling.enabled }}
{{- $fullName := include "openraven-java-spring.fullname" . }}
apiVersion: keda.sh/v1alpha1
kind: ScaledObject
metadata:
  name: {{ $fullName }}
  namespace: {{ .Release.Namespace }}
spec:
  advanced:
    {{/* https://keda.sh/docs/2.8/concepts/scaling-deployments/#horizontalpodautoscalerconfig */}}
    horizontalPodAutoscalerConfig:
      {{/* Keda delegates to the HPA https://kubernetes.io/docs/tasks/run-application/horizontal-pod-autoscale/#scaling-policies */}}
      behavior:
        scaleUp:
          stabilizationWindowSeconds: {{ .Values.autoscaling.scaleUpStabilizationWindowPeriod }}
          policies:
          - type: Pods
            value: {{ .Values.autoscaling.scaleUpValue }}
            periodSeconds: {{ .Values.autoscaling.scaleUpCooldown }}
        scaleDown:
          stabilizationWindowSeconds: {{ .Values.autoscaling.scaleDownStabilizationWindowPeriod }}
          policies:
          - type: Pods
            value: {{ .Values.autoscaling.scaleDownValue }}
            periodSeconds: {{ .Values.autoscaling.scaleDownCooldown }}
  maxReplicaCount: {{ .Values.autoscaling.maxReplicas }}
  minReplicaCount: {{ .Values.autoscaling.minReplicas | default .Values.replicaCount }}
  pollingInterval: {{ .Values.autoscaling.metricPollingInterval }}
  scaleTargetRef:
    name: {{ $fullName }}
  triggers:
{{- toYaml .Values.autoscaling.triggers | nindent 4 }}
{{ end }}
